﻿using System.ComponentModel.Composition;
using Microsoft.VisualStudio.Text;
using Microsoft.VisualStudio.Text.Classification;
using Microsoft.VisualStudio.Text.Projection;
using Microsoft.VisualStudio.Text.Tagging;
using Microsoft.VisualStudio.Utilities;


namespace JSOutlining11.Outlining
{
	[Export(typeof(ITaggerProvider))]
	[TagType(typeof(IOutliningRegionTag))]
	[ContentType("JavaScript")]	

	internal sealed class JSOutliningTaggerProvider : ITaggerProvider
	{
		[Import]
		IClassifierAggregatorService classifierAggregator;
        
        public ITagger<T> CreateTagger<T>(ITextBuffer buffer) where T : ITag
		{
			IClassifier classifier = classifierAggregator.GetClassifier(buffer);
			//var spans = c.GetClassificationSpans(new SnapshotSpan(buffer.CurrentSnapshot, 0, buffer.CurrentSnapshot.Length));
			
            //create a single tagger for each buffer.
            var res = buffer.Properties.GetOrCreateSingletonProperty(() => new JSOutliningTagger(buffer, classifier) as ITagger<T>);
            return res;
		} 
	}
}
