﻿using Microsoft.VisualStudio.Text;
using Microsoft.VisualStudio.Text.Classification;


namespace JSOutlining11.Outlining
{
	internal class JSOutliningTagger: BaseOutliningTagger
	{
		public JSOutliningTagger(ITextBuffer buffer, IClassifier classifier)
			: base(buffer, classifier)
		{
			
		}

		protected override void Init()
		{
			Outliner = new JSOutliner();
			base.Init();
		}

		protected override OutliningOptions GetOptions()
		{
			return new OutliningOptions
			{
				TabSize = 4,
		        AutoCollapseRegions = true
			};			
		}

        protected override System.Collections.Generic.List<TextRegion> GetRegionList(TextRegion tree)
        {
            //Visual Studio outlines functions itself, let's not conflict with it
            return base.GetRegionList(tree).FindAll(r => r.RegionSubType != TextRegionSubType.Function);
        }

        protected override SnapshotParser GetSnapshotParser(ITextSnapshot snapshot)
        {
            return new JSSnapshotParser(snapshot, Classifier);
        }
	}
}
